# DFF -- An Open Source Digital Forensics Framework
# Copyright (C) 2009-2011 ArxSys
# This program is free software, distributed under the terms of
# the GNU General Public License Version 2. See the LICENSE file
# at the top of the source tree.
#  
# See http://www.digital-forensic.org for more information about this
# project. Please do not directly contact any of the maintainers of
# DFF for assistance; the project provides a web site, mailing lists
# and IRC channels for your use.
# 
# Author(s):
#  Francois Percot <percot@gmail.com>
# 

import sys
from PyQt4 import QtCore, QtGui
from PyQt4.QtCore import QTranslator
# Import Singleton for CONF, actually unused, conf is global in ui.ui
from conf import Conf

class Translator(QTranslator):
    __instance = None
     
    def __new__(cls): 
        if cls.__instance is None:
            cls.__instance = QTranslator.__new__(cls)
        return cls.__instance
    
    def __init__(self):
        QTranslator.__init__(self)
        self.Conf = Conf()
        self.loadLanguage()
        
    def loadLanguage(self):
        return self.load(sys.modules['ui.gui'].__path__[0] + "/i18n/Dff_" + sys.modules['ui.ui'].interfaceLanguage.lower()[:2])
